【Codeforces-402D】-String Game (二分)

String Game
time limit per test
2 seconds
memory limit per test
512 megabytes
input
standard input
output
standard output

Little Nastya has a hobby, she likes to remove some letters from word, to obtain another word. But it turns out to be pretty hard for her, because she is too young. Therefore, her brother Sergey always helps her.

Sergey gives Nastya the word t and wants to get the word p out of it. Nastya removes letters in a certain order (one after another, in this order strictly), which is specified by permutation of letters' indices of the word ta1... a|t|. We denote the length of word x as |x|. Note that after removing one letter, the indices of other letters don't change. For example, if t = "nastya" and a = [4, 1, 5, 3, 2, 6] then removals make the following sequence of words "nastya "nastya "nastya "nastya "nastya "nastya"nastya".

Sergey knows this permutation. His goal is to stop his sister at some point and continue removing by himself to get the word p. Since Nastya likes this activity, Sergey wants to stop her as late as possible. Your task is to determine, how many letters Nastya can remove before she will be stopped by Sergey.

It is guaranteed that the word p can be obtained by removing the letters from word t.

Input

The first and second lines of the input contain the words t and p, respectively. Words are composed of lowercase letters of the Latin alphabet (1 ≤ |p| < |t| ≤ 200 000). It is guaranteed that the word p can be obtained by removing the letters from word t.

Next line contains a permutation a1, a2, ..., a|t| of letter indices that specifies the order in which Nastya removes letters of t (1 ≤ ai ≤ |t|, all ai are distinct).

Output

Print a single integer number, the maximum number of letters that Nastya can remove.

Examples
input
ababcba
abb
5 3 4 1 7 6 2
output
3
input
bbbabb
bb
1 6 3 4 2 5
output
4
Note

In the first sample test sequence of removing made by Nastya looks like this:

"ababcba "ababcba "ababcba "ababcba"

Nastya can not continue, because it is impossible to get word "abb" from word "ababcba".

So, Nastya will remove only three letters.


题意:给两个串,和一个序列。按照序列的顺序依次划掉str1的字符,问最多可以划多少次还包含str2

题解:最多划掉l2-l1,最少0,所以二分划掉次数。用一个数组 a[] 存放第 t 个字符会在第 i 次被划掉

重点理解:

if(a[pos1]<=mid)	//pos1位置删除第a[pos1]个字母,若a[pos1]<=mid表示已被删除,所以pos1++ 
		{
			pos1++;
			continue;
		}
若str1上的第pos1个字符被划掉的标号<=mid就说明一定被划掉,这个字符不存在了,pos1++

#include <cstdio>
#include <stack>
#include <queue>
#include <cmath>
#include <vector>
#include <cstring>
#include <algorithm>
using namespace std;
#define CLR(a,b) memset(a,b,sizeof(a))
#define INF 0x3f3f3f3f
#define LL long long
int l1,l2;	
int a[200010];			//	存放字符被删的次序 
char str1[200010],str2[200010];
bool check(int mid)
{
	int pos1=1,pos2=1;
	while(pos2<=l2)
	{
		if(pos1>l1)	
			return false;
		if(a[pos1]<=mid)	//pos1位置删除第a[pos1]个字母,若a[pos1]<=mid表示已被删除,所以pos1++ 
		{
			pos1++;
			continue;
		}
		if(str1[pos1]==str2[pos2]) 		//pos1没有被删除,且两串当前位置字符相等,pos都+1 
		{
			pos1++;
			pos2++;
			continue;
		}
		else				//str1向后移一位 
			pos1++;
	}
	return true;
}
int main()
{
	scanf("%s%s",str1+1,str2+1);
	l1=strlen(str1+1);
	l2=strlen(str2+1);
	for(int i=1;i<=l1;i++)
	{
		int t;
		scanf("%d",&t);
		a[t]=i;				//第 t个字符,第a[t]次被删 
	} 
	int l=0,r=l1-l2;			//对可删除的数目二分,最多是l1-l2个 
	while(l<=r)
	{
		int mid=(l+r)>>1;
		if(check(mid))
			l=mid+1;		//这里仍然成立,所以应该多划掉些 
		else
			r=mid-1;
	}
	printf("%d\n",r);
	return 0;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值